require 'nmax/version'
require 'cri'

module Nmax
  def self.get_nmax_from_stream(stream, n)
    nmax_numbers = []
    stream.each_line do |line|
      current_line_numbers = get_nmax_from_string(line, n)
      sorted_numbers = (nmax_numbers + current_line_numbers).sort.reverse
      nmax_numbers = sorted_numbers.size >= n ? sorted_numbers[-n, n] : sorted_numbers
    end
    nmax_numbers
  end

  def self.get_nmax_from_string(string, n)
    return [] if string.empty? || n.nil? || n.zero?
    numbers = string.scan(/\d{1,1000}/).map(&:to_i)
    sorted_numbers = numbers.sort
    return sorted_numbers[-n, n] if sorted_numbers.size >= n
    sorted_numbers
  end

  def self.print(nmax_numbers)
    nmax_numbers.each do |number|
      puts "#{number}\n"
    end
  end
end
